function [candidate b_size]= RandomMask4x(HSig, peaks, num_round_mask, nbit_mask, th_min_blk)
    global gap1 gap2 boundary;
    global s1 s2;

    max_bucket = zeros(num_round_mask,1);
    candidate = zeros(10,2);
    count = 0;     
    nh = size(HSig,1);
    if (nh ==0)
           candidate = 0;
           b_size = 0;
           return;
    end;
    NE(nh,1)=true;
    for round_mask = 1:num_round_mask
        mask = randperm(size(HSig,2));     %ds*ds
        LM = HSig;
        LM(:, mask(1:nbit_mask)) = [];
        [SL Six] = sortrows(LM); 
        
        NE(1:nh-1,1) = any(SL(1:end-1,:)~=SL(2:end,:)  , 2);  
        %%NE(end+1,1) = true;
        %Initial
        
        e = find(NE);
        max_bucket(round_mask) = max(e(1:end,1) - [0; e(1:end-1,1)]);
        
        st = 1;
        for i=1:length(NE)
            ind1 = Six(i);
            x1 = peaks(ind1,1);
            y1 = peaks(ind1,2);
            if (peaks(ind1,3)<th_min_blk)                    , continue; end

            for j=st:i-1
                ind2 = Six(j);
                x2 = peaks(ind2,1);
                y2 = peaks(ind2,2);
                if (peaks(ind2,3)<th_min_blk)                , continue; end
                if ((abs(x1-x2)<=gap1)&&(abs(y1-y2)<=gap2))  , continue; end
                
                if (IsFromDiffPic(y1, y2))     
                    count = count+1;
                    if (count > size(candidate))    
                        candidate(end*2,:) = [0 0]; 
                    end;                               
                    candidate(count,:) = [ind2 ind1];                    
                end
                %%AAAAAAAAAAAAAAAAAAAAAAAAAAA                                
            end
            if (NE(i)==1)
                st = i+1;
            end
        end
        candidate(count+1:end,:)=[];

    end
    b_size = max(max(max_bucket)); 

    
    
%%
function flag = IsFromDiffPic(ind1, ind2)
    global boundary s2;
    if (((ind1 +s2<=boundary)&&(ind2>boundary)) || ((ind1>boundary)&&(ind2+s2 <=boundary)))
        flag = true;
    else
        flag = false;
    end

