function lb = lb_1_qiang(q,c,sumQ)      
    %a and b are signatures
    %time n^2 + early abandon
    if (nargin < 3)
        sumQ = sum(q);        
    end
    
    if (isempty(q) || isempty(c))
        lb =  sumQ;
        return
    end
    sq = size(q,2);
    sc = size(c,2);
    bsf_lb = sumQ;
    missed = 0;
%     list(1,:)=[0 0];
    for r = 1-sq:1:sc-1
        missed = 0;
        for i = 1:sq
            j = i+r;
%             list(end+1,:)=[i j];
            if (j<1)||(j>sc)
                cost = q(i);
            else
                cost = q(i)-c(j);
                if (cost < 0)
                    cost = 0;
                end
            end
            missed = missed + cost;
            
            if (missed > bsf_lb)
                break;
            end
        end
        if (missed < bsf_lb)
            bsf_lb = missed;
        end
    end
    lb = bsf_lb;
%     list
end